/*
	CsoundKRateCmd.h - set kr for csound orc file

	Will Eighteen, 2000: will@opaline.demon.co.uk             
*/

#ifndef CSOUNDKRATECMD_H
#define CSOUNDKRATECMD_H

#include "Cmd.h"

typedef void ( *enterCallback ) ( void *, char * );
typedef void ( *cancelCallback ) ( void * );


class LineEdit;


class CsoundKRateCmd : public Cmd
{
	protected:
		virtual void doCommand();
		virtual void undoCommand();
		
	public:
		CsoundKRateCmd ( const char *, int active = TRUE );
		virtual const char *const className() { return ( "CsoundKRateCmd" ); }
		
	private:
		// note 'ok' is mapped to 'enter' by LineEdit
		static void enterCallback ( void *, char * );
		static void cancelCallback ( void * );
		void enter( float );
		LineEdit *_edit;
		Boolean _popupRealised;
};

#endif

/*
  Notes:
  
  UndoCommand is not implemented here.
  
  The 'cancel' command is defaulted in LineEdit.
  
  'doCommand()' should provide a resource to be displayed.
  'enter' should set a resource from text retrieved from the text widget.
*/
