/*
 MainWindow.h - create application's top-level window
 Modified by Will 18, 2001; will@opaline.demon.co.uk
 Added private protocol callback to disallow WM_DELETE_WINDOW

 Adapted from
 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.
*/


#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "Interface.h"

class MainWindow : public Interface
{
	public:
		MainWindow ( const char * );
		virtual ~MainWindow();
		virtual void initialize();
		virtual void manage();
		virtual void unmanage();
		virtual void iconify();
		
	protected:
		Widget _main;		// XmMainWindow widget
		Widget _workArea;	// widget created by derived class
		virtual Widget createWorkArea ( Widget ) = 0;
		
	private:
		static void clientMessageProc ( Widget, XtPointer, XtPointer );
};

#endif

/*
  Notes:
  
  The constructor only requires a name.
  
  initialize() is automatically called by the Application class for all
  registered main window objects.
  
  Derived classes must define createWorkArea() to create the app-specific work
  area.
  
  The MainWindow constructor calls the Interface constructor, then registers the
  new object with the program's Application object.
*/
